<?php

//file_put_contents( "D:\\pete.txt", print_r( $argv, TRUE ) );

// $argv[1] should have the path to the PNG image
$path = pathinfo( $argv[1] );

$infile = $argv[1];
$outfile = $path["dirname"] ."\\". $path["filename"] .".tiles.h";

if( ! ( $image = imagecreatefrompng( $infile ) ) )
{
	file_put_contents( $outfile, "Error abriendo el PNG: ".$infile );
	exit( 1 );
}
// else

$width = imagesx( $image );
$height = imagesy( $image );

$tilew = $width / 8;
$tileh = $height / 8;

$output = "\r\n// Original file: ". $infile ."\r\n";
$output .= "// Dimensions: ". $width ." x ". $height ." pixels, ". $tilew ." x ". $tileh ." tiles\r\n\r\n";

for( $tiley = 0; $tiley < $tileh; ++$tiley )
{
	// in this block, one tile row is processed
	
	for( $tilex = 0; $tilex < $tilew; ++$tilex )
	{
		// in this block, one tile is processed
		
		$tile1half = array(0,0,0,0,0,0,0,0); // low bit of each pixel"s color
		$tile2half = array(0,0,0,0,0,0,0,0); // high bit of each pixel"s color
				
		$output .= "// Tile #". ($tilew*$tiley+$tilex) ." : ( column ". $tilex .", row ". $tiley ." ) \r\n";
		$output .= "// +--------+\r\n";
		
		for( $intiley = 0; $intiley < 8; ++$intiley )
		{
			// in this block, one pixel row is porecessed
			
			$row1half = 0;
			$row2half = 0;
			
			$output .= "// |";
			
			for( $intilex = 0; $intilex < 8; ++$intilex )
			{
				// in this block, one pixel is processed
				
				$x = $tilex * 8 + $intilex;
				$y = $tiley * 8 + $intiley;
				$color = imagecolorat( $image, $x, $y );
				$color %= 4; // All color indexes map to [0..3]
				
				$tile[ $intilex ][ $intiley ] = $color;
				
				$row1half |= ( $color & 1 ); // insert low bit of color
				
				if( $intilex < 7 )
					$row1half <<= 1; // shift left to insert next bit
				
				$row2half |= ( ( $color & 2 ) >>1 ); // insert high bit of color
				
				if( $intilex < 7 )
					$row2half <<= 1; // shift left to insert next bit				
				
				$output .= ( $color == 0 ? "." : $color );
			}
			
			$output .= "|\r\n";
			
			// this pixel row is finished
			
			$tile1half[ $intiley ] = $row1half;
			$tile2half[ $intiley ] = $row2half;
		}
		
		$output .= "// +--------+\r\n";
		
		// this tile is finished
		
		for( $i=0; $i<8; ++$i )
			$output .= sprintf( "0x%02X, ", $tile1half[$i] );
		$output .= "\r\n";
		for( $i=0; $i<8; ++$i )
			$output .= sprintf( "0x%02X, ", $tile2half[$i] );
		$output .= "\r\n\r\n";
	}
}

/*
for( $y = 0; $y < $height; $y++ )
{
	$output .= "// ";
	for( $x = 0; $x < $width; $x++ )
	{
		$color = imagecolorat( $image, $x, $y );
		$output .= ( $color == 0 ? " " : $color );
		if( $x % 8 == 7 )
			$output .= "|";
	}
	$output .= "\r\n";
}
*/

file_put_contents( $outfile, $output );

imagedestroy( $image );


















?>